#ifndef _screen_h
#define _screen_h

#ifdef _WIN32
	#include <windows.h>	// required by gl.h
#endif
#include <GL/gl.h>
#include <GL/glu.h>

#include "SDL_opengl.h"

#include "pie_types.h"


class CScreen {
public:
	PFNGLGENBUFFERSARBPROC glGenBuffersARB;
	PFNGLBINDBUFFERARBPROC glBindBufferARB;
	PFNGLBUFFERDATAARBPROC glBufferDataARB;
	PFNGLBUFFERSUBDATAARBPROC glBufferSubDataARB;
	PFNGLDELETEBUFFERSARBPROC glDeleteBuffersARB;
	PFNGLGETBUFFERPARAMETERIVARBPROC glGetBufferParameterivARB;
	PFNGLMAPBUFFERARBPROC glMapBufferARB;
	PFNGLUNMAPBUFFERARBPROC glUnmapBufferARB;

	Uint16	m_width;	///<width of window
	Uint16	m_height;	///<height of window
	Sint32	m_bpp;	///<bit per pixel
	Uint32	m_flags;	///<SDL surface flags
	bool	m_useVBO;	///uses VBO or not

	int		initialize(void);
	void	initializeVBOExtension(void);
	bool	setVideoMode(void);
	SDL_Surface	*m_Surface;

};

extern CScreen g_Screen;

#endif
